#ifndef __THE_MAZE_OF_GALIOUS_2_ACTIVE_ROOM
#define __THE_MAZE_OF_GALIOUS_2_ACTIVE_ROOM


class ActiveROOM {
	friend class GameWindow;
	friend class GameDebugWindow;
	friend class NetworkGameWindow;

	friend class ActiveMOG2;
	friend class ActiveMAP;
	friend class ActiveOBJECT;
	friend class ActiveINTERFACE;

	friend class ActionSCRIPT;
	friend class ConditionSCRIPT;
	friend class ValueSCRIPT;

public:
	ActiveROOM(ROOM *r,class ActiveMAP *map,class ActiveMOG2 *game);
	~ActiveROOM(void);

	bool save(FILE *fp);
	bool load(FILE *fp);

	bool cycle(class KEYBOARDSTATE **LVK,int n_LVKs);

	/* The focusing_hs parameter specifies the window in which the Hot-Spot of the focusing	*/ 
	/* object has to be placed. The room will scroll in order to acomplish this.			*/ 
	void draw(SDL_Surface *sfc,SDL_Rect vp,List<ActiveOBJECT> *focusing_objects,SDL_Rect *focusing_hs);
	void draw_internal(SDL_Surface *sfc,SDL_Rect vp,int x_offs,int y_offs);

	int room_object_collision(ActiveOBJECT *o,bool hierarchical);
	int room_object_collision(ActiveOBJECT *o,int x,int y,bool hierarchical);
	bool room_object_to_character_collision(ActiveOBJECT *o);
	bool room_object_to_character_collision(ActiveOBJECT *o,int x,int y);

	ActiveOBJECT *room_object_collision2(ActiveOBJECT *o,int x,int y,int constitution,ConditionSCRIPT *s,ActiveOBJECT **foreign_object,bool hierarchical);

	void place_character_in_safe_place(ActiveOBJECT *o);

	bool find_object(ActiveOBJECT *o);
	void remove_object_references(ActiveOBJECT *o);

	int get_variable_value(char *vname,int *ival,char **sval,ActiveOBJECT **oval);
	void set_variable_value(char *vname,int value);
	void set_variable_value(char *vname,char *value);
	void set_variable_value(char *vname,ActiveOBJECT *value);

private:
	void create_collision_mask(void);

	void get_collision_grid_area(int x1,int y1,int x2,int y2,int *gx1,int *gy1,int *gx2,int *gy2); 


	List<VARIABLE> room_variables;
	ROOM *room;

	ActiveMAP *map;
    ActiveMOG2 *game;

	int viewx,viewy;	/* start position for drawing */ 
    int last_active_cycle;

	class ActionSCRIPT *room_action;
	class ActiveOBJECT *script_foreign_object;

	// Room background: 
	SDL_Surface *back_sfc;
	MOG2CollisionData *collision_data; 

	// Room objects: 
	List<ActiveOBJECT> objects[MAX_OBJECT_PLANES];

	List<ActiveOBJECT> objects_toadd[MAX_OBJECT_PLANES];
	List<ActiveOBJECT> objects_to_change_plane;

	List<class DRAWCOMMAND> draw_commands;

    // Quick lists:
    List<ActiveOBJECT> nonpassive_objects[MAX_OBJECT_PLANES];
	List<ActiveOBJECT> *collision_grid_new;
	List<ActiveOBJECT> *collision_grid_old_x;
	List<ActiveOBJECT> *collision_grid_old_y;
	List<ActiveOBJECT> *collision_grid_old_xy;
};

#endif

