#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"
#include "MOG2_auxiliar.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BKeySelectionDlg.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BKeyDlg::BKeyDlg(int x,int y,int dx,int dy,char *q,int *ek,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int but_x=70;

	query=q;
	current_key=*ek;
	editing_key=ek;

	b=new BButton(but_x,dy-20,get_text_width("ACCEPT",font)+10,12,"ACCEPT",1);
	buttons.Add(b);
	but_x+=get_text_width("ACCEPT",font)+20;

	b=new BButton(but_x,dy-20,get_text_width("CANCEL",font)+10,12,"CANCEL",2);
	buttons.Add(b);

	b=new BButton(10,dy-60,50,12,"LEFT",3);
	buttons.Add(b);
	b=new BButton(70,dy-60,50,12,"RIGHT",4);
	buttons.Add(b);
	b=new BButton(130,dy-60,50,12,"UP",5);
	buttons.Add(b);
	b=new BButton(190,dy-60,50,12,"DOWN",6);
	buttons.Add(b);
	b=new BButton(10,dy-40,50,12,"FIRE 1",7);
	buttons.Add(b);
	b=new BButton(70,dy-40,50,12,"FIRE 2",8);
	buttons.Add(b);
	b=new BButton(130,dy-40,50,12,"FIRE 3",9);
	buttons.Add(b);
	b=new BButton(190,dy-40,50,12,"FIRE 4",10);
	buttons.Add(b);
	b=new BButton(190,dy-80,50,12,"ANY",11);
	buttons.Add(b);


} /* BIntegerEdDlg::BIntegerEdDlg */ 


BKeyDlg::~BKeyDlg()
{
} /* BIntegerEdDlg::~BIntegerEdDlg */ 


void BKeyDlg::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BIntegerEdDlg::contens_size */ 


void BKeyDlg::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	print_centered(query,font,255,255,255,sfc,sfc->w/2-stx,8-sty);

	print_left(input_key_name(current_key),font,255,255,255,sfc,15-stx,(dy-80)-sty);

} /* BKeyDlg::draw_contens */ 


bool BKeyDlg::event(SDL_Event *event)
{
	if (event->type==SDL_KEYDOWN) {
		/* Keyboard event */ 
		current_key=event->key.keysym.sym;
		dirty=true;
    } /* if */ 

	return true;
} /* BKeyDlg::Event */ 


bool BKeyDlg::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		*editing_key=current_key;
		return false;
		break;
	case 2:
		return false;
		break;
	case 3:
		current_key=-1;
		break;
	case 4:
		current_key=-2;
		break;
	case 5:
		current_key=-3;
		break;
	case 6:
		current_key=-4;
		break;
	case 7:
		current_key=-5;
		break;
	case 8:
		current_key=-6;
		break;
	case 9:
		current_key=-7;
		break;
	case 10:
		current_key=-8;
		break;
	case 11:
		current_key=-9;
		break;
	} /* switch */ 

	set_dirty();
	return true;
} /* BKeyDlg::button_pressed */ 

